# -*- coding: utf-8 -*-  
import os,sys,gc
from osgeo import gdal
#import gdal
import numpy as np
import shapefile
import matplotlib.pyplot as plt
import math
import pandas as pd
from sys import argv
from data_connect import DATAConncet

# dem_file = argv[1]
# cat_file = argv[2]
# outpath = argv[3]
pixval = 30 * 30;
step = 5;
def main(dem_file,cat_file,outpath):
    fp_dem = gdal.Open(dem_file, gdal.GA_ReadOnly);
    dataset_dem = fp_dem.GetRasterBand(1).ReadAsArray(0, 0, fp_dem.RasterXSize, fp_dem.RasterYSize);
    fp_cat = gdal.Open(cat_file, gdal.GA_ReadOnly);
    dataset_cat = fp_cat.GetRasterBand(1).ReadAsArray(0, 0, fp_cat.RasterXSize, fp_cat.RasterYSize);
    cat_tmp = dataset_cat[dataset_cat < 65530];
    #print(dataset_dem.shape, dataset_cat.shape);
    #print(dataset_cat.min());
    #print(dataset_dem.min(), dataset_dem.max());
    #print(dataset_dem[dataset_cat==0]);
    H_list = [];
    print("process start ", 1, cat_tmp.max());
    for i in range(1, cat_tmp.max() + 1):
        if(i % 100 == 0):
            print('i=%d'%i, end = ' ', flush = True);
        dem_cat = dataset_dem[dataset_cat==i];
        if dem_cat.shape[0] > 0:
            dem_cat = dem_cat[dem_cat < 8000];
            A = dem_cat.shape[0] * pixval;
            dem_cat_max = dem_cat.max();
            dem_cat_min = dem_cat.min();
            
            Hm = dem_cat_max - dem_cat_min;
            contour = dem_cat_max - step;
            S = 0;
            X = [];
            Y = [];
            x_pre = 0;
            while(contour > dem_cat_min):
                a = dem_cat[dem_cat >= contour].shape[0] * pixval;
                h = contour - dem_cat_min;
                x = a / A;
                y = h / Hm;
                X.append(x);
                Y.append(y);
                contour -= step;
                S = S + (x-x_pre)*y;
                x_pre = x;
            #print("X=",X);
            #plt.plot(X, Y);
            #plt.savefig("./temp.png");
            #print(S);
            if S > 0:
                H = S - math.log(S) -1;
            else:
                H = 0;
            #print ("H =" , H);
            H_list.append((i, H));
    print('\n');
    print("process complete");
    print(H_list)

    fp = open(outpath, 'w');
    fp.write("%s,%s\n" % ("hydroid", "entropy"));
    for item in H_list:
        fp.write("%d,%.2f\n" % (item[0], item[1]));
    fp.close();

if __name__ == '__main__':
    dataConnect = DATAConncet()

    # dem_file = "/data2/bcdt1/DamDetect/数据/榆林市DEM数据TIF/2019年中国榆林市30m数字高程数据集.tif";
    # cat_file = "/data2/bcdt1/DamDetect/数据/榆林市集水区数据TIF/2019年中国榆林市集水区栅格.tif";
    # outpath='/data2/bcdt1_docker/siltdam/out/geoentropy_res.txt';

    # 获取上游传递数据（路径 ）
    dem_file = dataConnect.dataInputStream("demPort").iloc[0, 0]
    cat_file = dataConnect.dataInputStream("catPort").iloc[0, 0]
    outpath = argv[1]

    #自动创建输出文件夹
    parentDir = os.path.dirname(outpath)
    isExists = os.path.exists(parentDir)
    if not isExists : os.makedirs(parentDir)


    dataConnect.downloadFileFromHdfs(dem_file, dem_file, False)
    dataConnect.downloadFileFromHdfs(cat_file, cat_file, False)
    
    main(dem_file,cat_file,outpath);

    df = pd.read_csv(outpath)
    print(df)
    dataConnect.dataOutputStream(df,"geoentropy_port")


    
    # # 将输出结果上传到 hdfs 
    # dataConnect.putFileToHdfs(outpath, outpath, True)

    # # 结果路径传递下去
    # out_df = pd.DataFrame([outpath],dtype='string',columns=['outpath'])
    # print(out_df)  
    # dataConnect.dataOutputStream(out_df, "entropyPort")

