# -*- coding: utf-8 -*-  
import os,sys,gc
from osgeo import gdal
import numpy as np
import shapefile
import matplotlib.pyplot as plt
import math
import pandas as pd
from sys import argv
from data_connect import DATAConncet


def GDAL_GetRasterPos(X, Y, GeoTable):
    a = GeoTable;
    col = (a[5] * (X - a[0]) - a[2] * (Y - a[3])) / (a[1] * a[5] - a[2] * a[4]);
    row = (a[4] * (X - a[0]) - a[1] * (Y - a[3])) / (a[2] * a[4] - a[1] * a[5]);
    return int(row), int(col);


def main(dl_record_file,dem_file,outpath):
    fp_dem = gdal.Open(dem_file, gdal.GA_ReadOnly);
    dataset_dem = fp_dem.GetRasterBand(1).ReadAsArray(0, 0, fp_dem.RasterXSize, fp_dem.RasterYSize);
    df = pd.read_csv(dl_record_file);
    df_sort = df.sort_values(by='GridID', ascending=True);
    print (df_sort.iloc[0,8:13])
    print (df_sort.shape[0]);
    print (df_sort.iloc[0,8:13].start_p);
    print (fp_dem.GetGeoTransform());
    print (GDAL_GetRasterPos(df_sort.iloc[0,8:13].start_p, df_sort.iloc[0,8:13].start_l, fp_dem.GetGeoTransform()));
    geotable = fp_dem.GetGeoTransform();
    #起点DEM数值大于终点
    dec_rate_list = [];
    k = 0;
    for i in range(0, df_sort.shape[0]):
        line = df_sort.iloc[i];
        startp_row, startp_col = GDAL_GetRasterPos(line.start_p, line.start_l, geotable);
        endp_row, endp_col = GDAL_GetRasterPos(line.end_p, line.end_l, geotable);
        if dataset_dem[startp_row][startp_col] < 0:
            sub = dataset_dem[startp_row - 2 : startp_row + 2, startp_col - 2 : startp_col + 2];
            start_dem = int(sub[sub > 0].mean());
        else:
            start_dem = dataset_dem[startp_row][startp_col];
        if dataset_dem[endp_row][endp_col] < 0:
            sub = dataset_dem[endp_row - 2 : endp_row + 2, endp_col - 2 : endp_col + 2];
            end_dem = int(sub[sub > 0].mean());
        else:
            end_dem = dataset_dem[startp_row][startp_col];
        dec_rate = math.fabs(start_dem - end_dem) / line.Shape_Length;
        dec_rate_list.append(dec_rate * 100);
    df['gully_slop'] = dec_rate_list;
    df.to_csv(outpath, index=False);
    
if __name__ == '__main__':
    dataConnect = DATAConncet()
   
    # dl_record_file = "/data2/bcdt1/DamDetect/数据/榆林市沟道数据csv/2019年中国榆林市沟道信息.csv";
    # dem_file = "/data2/bcdt1/DamDetect/数据/榆林市DEM数据TIF/2019年中国榆林市30m数字高程数据集.tif";
    # outpath = "/data2/bcdt1_docker/siltdam/out/gully_slop.csv"

    # main(dl_record_file,dem_file,outpath);

    # 获取上游传递数据（路径 ）
    dl_record_file = dataConnect.dataInputStream("recordPort").iloc[0, 0]
    dem_file = dataConnect.dataInputStream("demPort").iloc[0, 0]
    outpath = argv[1]

    #自动创建输出文件夹
    parentDir = os.path.dirname(outpath)
    isExists = os.path.exists(parentDir)
    if not isExists : os.makedirs(parentDir)

    
    dataConnect.downloadFileFromHdfs(dl_record_file, dl_record_file, False)
    dataConnect.downloadFileFromHdfs(dem_file, dem_file, False)
    
    main(dl_record_file,dem_file,outpath);
    
    df = pd.read_csv(outpath)
    print(df)
    dataConnect.dataOutputStream(df,"gully_slop_port")
