# -*- coding: utf-8 -*-  
from osgeo import gdal
import os
import numpy as np
import math
import pandas as pd
from sys import argv
from data_connect import DATAConncet

bias = 3;

def GDAL_GetRasterPos(X, Y, GeoTable):
    a = GeoTable;
    col = (a[5] * (X - a[0]) - a[2] * (Y - a[3])) / (a[1] * a[5] - a[2] * a[4]);
    row = (a[4] * (X - a[0]) - a[1] * (Y - a[3])) / (a[2] * a[4] - a[1] * a[5]);
    return int(row), int(col);

def main(Drainagefile,sphydrofile_df,labelpath_df,outpath):
    raw, select = [], [];
    # dfsp = pd.read_csv(sphydrofile);
    dfsp= sphydrofile_df;
    print(dfsp);
    fp = gdal.Open(Drainagefile, gdal.GA_ReadOnly);
    raster = fp.GetRasterBand(1).ReadAsArray(0, 0, fp.RasterXSize, fp.RasterYSize);
    geotable = fp.GetGeoTransform();
    
    df = labelpath_df
    df.columns = ['lon', 'lat', 'width', 'height'];
    labelfile="demo.tif"
    for i in range(0, df.shape[0]):
        raw.append([df.iloc[i,:].lon, df.iloc[i,:].lat, labelfile]);
        row, col = GDAL_GetRasterPos(df.iloc[i,:].lon, df.iloc[i,:].lat, geotable);
        sub = raster[row - bias : row + bias + 1, col - bias : col + bias + 1];
        tmp = sub[sub > 0];
        if tmp.shape[0] > 0:
            hyid = tmp[0];
            if hyid in dfsp.HydroID.values:
                select.append([df.iloc[i,:].lon, df.iloc[i,:].lat, hyid, labelfile]);

    # labelfiles = os.listdir(labelpath);
    # for labelfile in labelfiles:
    #     fname = os.path.join(labelpath, labelfile);
    #     df = pd.read_csv(fname, header = None)
    #     df.columns = ['lon', 'lat', 'width', 'height'];
    #     for i in range(0, df.shape[0]):
    #         raw.append([df.iloc[i,:].lon, df.iloc[i,:].lat, labelfile]);
    #         row, col = GDAL_GetRasterPos(df.iloc[i,:].lon, df.iloc[i,:].lat, geotable);
    #         sub = raster[row - bias : row + bias + 1, col - bias : col + bias + 1];
    #         tmp = sub[sub > 0];
    #         if tmp.shape[0] > 0:
    #             hyid = tmp[0];
    #             if hyid in dfsp.HydroID.values:
    #                 select.append([df.iloc[i,:].lon, df.iloc[i,:].lat, hyid, labelfile]);
    dfraw = pd.DataFrame(raw, columns = ['lon', 'lat', 'imgname']);
    #dfraw.to_csv('DamDetect.csv')
    dfsel = pd.DataFrame(select, columns = ['lon', 'lat', 'hydroid','imgname']);
    # dfsel.to_csv(outpath,index=False)
    dfsel.to_csv(outpath)

if __name__ == '__main__':
    dataConnect = DATAConncet()
    # Drainagefile = "/data2/bcdt1/DamDetect/数据/榆林市沟道数据TIF/2019年中国榆林市沟道栅格wgs.tif";
    # sphydrofile = "/data2/bcdt1/DamDetect/suscep_hdyro.csv"
    # labelpath = "/data2/bcdt1/DamDetect/LabelsLR";
    # outpath = "/data2/bcdt1_docker/siltdam/out/SelectDam/DamDetect_select1.csv";

    # # 获取上游传递数据（路径 ）
    # Drainagefile = "2019年中国榆林市沟道栅格wgs.tif";
    sphydrofile_df = dataConnect.dataInputStream("suscep_hdyro_port")
    labelpath_df = dataConnect.dataInputStream("label_port")
    Drainagefile="/pythonDir/2019wgs.tif"
    outpath="/overlap_dam_select.csv"

    #自动创建输出文件夹
    parentDir = os.path.dirname(outpath)
    isExists = os.path.exists(parentDir)
    if not isExists : os.makedirs(parentDir)

    main(Drainagefile,sphydrofile_df,labelpath_df,outpath);

    # pd.read_csv("/data2/bcdt1/DamDetect/LabelsLR")
    # label_df = pd.DataFrame()
    # labelfiles = os.listdir("/data2/bcdt1/DamDetect/LabelsLR");
    # for labelfile in labelfiles:
    #     fname = os.path.join(labelpath, labelfile);
    #     label_df= label_df.append(pd.read_csv(fname, header = None))
    

    df = pd.read_csv(outpath)
    print(df)
    dataConnect.dataOutputStream(df,"damDetect_port")